###################################################################################################
# Legislative Organization and Political Representation ###########################################
# Master File #####################################################################################
# Michael Olson and Jon Rogowski ##################################################################
###################################################################################################

###################################################################################################
# working directory ###############################################################################
###################################################################################################

  setwd("C:/Users/michael.p.olson/Dropbox/Research/committee_responsiveness/replication_package")
    # change this to the top level of the replication package folder on your system
    # all file loads/saves are relative to this top level

###################################################################################################
# install packages ################################################################################
###################################################################################################

# note -- if any of these packages are already installed, please *remove* them using remove.packages()
# and then close and re-open R before running this script. Sometimes installs over existing ones
# work fine, other times they can be quite fussy.

# note also that rtools must be installed to build these: https://cran.r-project.org/bin/windows/Rtools/rtools42/rtools.html

# parallely (dependency)

  install.packages("./rpackages/parallelly_1.36.0.tar.gz",repo = NULL, type="source")

# sjlabelled (dependency)

  install.packages("./rpackages/sjlabelled_1.2.0.tar.gz",repo = NULL, type="source")

# future (dependency)

  install.packages("./rpackages/future_1.33.0.tar.gz",repo = NULL, type="source")
  
# AER (dependency)
  
  install.packages("./rpackages/AER_1.2-10.tar.gz",repo = NULL, type="source")
  
# ModelMetrics (dependency)
  
  install.packages("./rpackages/ModelMetrics_1.2.2.2.tar.gz",repo = NULL, type="source")
  
# mvtnorm (dependency)
  
  install.packages("./rpackages/mvtnorm_1.2-2.tar.gz",repo = NULL, type="source")
  
# pcse (dependency)
  
  install.packages("./rpackages/pcse_1.9.1.1.tar.gz",repo = NULL, type="source")
  
# ggplotify (dependency)
  
  install.packages("./rpackages/ggplotify_0.1.1.tar.gz",repo = NULL, type="source")
  
# doParallel (dependency)
  
  install.packages("./rpackages/doParallel_1.0.17.tar.gz",repo = NULL, type="source")
  
# Lmoments (dependency)
  
  install.packages("./rpackages/Lmoments_1.3-1.tar.gz",repo = NULL, type="source")

# dplyr (for data manipulation)

  install.packages("./rpackages/dplyr_1.1.0.tar.gz",repo = NULL, type="source")

# foreign (for loading dbf files)

  install.packages("./rpackages/foreign_0.8-84.tar.gz",repo = NULL, type="source")

# readxl (for loading excel files)

  install.packages("./rpackages/readxl_1.4.2.tar.gz",repo = NULL, type="source")

# haven (for loading stata files)

  install.packages("./rpackages/haven_2.5.1.tar.gz",repo = NULL, type="source")
  
# stringr (for cleaning character strings)
  
  install.packages("./rpackages/stringr_1.5.0.tar.gz",repo = NULL, type="source")
  
# purrr (required by tidyr)
  
  install.packages("./rpackages/purrr_1.0.1.tar.gz",repo = NULL, type="source")
  
# tidyr (for reorganizing data)
  
  install.packages("./rpackages/tidyr_1.3.0.tar.gz",repo = NULL, type="source")
  
# datacombine (for lags and leads)
  
  install.packages("./rpackages/DataCombine_0.2.21.tar.gz",repo = NULL, type="source")
  
# plyr (for rename function)
  
  install.packages("./rpackages/plyr_1.8.8.tar.gz",repo = NULL, type="source")

# lfe (used for fixed effects models)

  install.packages("./rpackages/lfe_2.9-0.tar.gz",repo = NULL, type="source")
  
# ggplot2 (for visualizing results)
  
  install.packages("./rpackages/ggplot2_3.4.1.tar.gz",repo = NULL, type="source")
  
# english (for translating integers to english character strings)
  
  install.packages("./rpackages/english_1.2-6.tar.gz",repo = NULL, type="source")
  
# interflex (for marginal effects plots)
  
  install.packages("./rpackages/interflex_1.2.6.tar.gz",repo = NULL, type="source")
  
# vtable (for summary stats tables)
  
  install.packages("./rpackages/vtable_1.4.1.tar.gz",repo = NULL, type="source")

# stargazer (for pretty tables)
# there's some funkiness with the newest version of stargazer, so I use this code,
# borrowed from here: https://gist.github.com/alexeyknorre/b0780836f4cec04d41a863a683f91b53
# to load it in with a helpful fix
  
  untar("./rpackages/stargazer_5.2.3.tar.gz")
  # Read the sourcefile with .inside.bracket fun
  stargazer_src <- readLines("stargazer/R/stargazer-internal.R")
  # Move the length check 5 lines up so it precedes is.na(.)
  stargazer_src[1990] <- stargazer_src[1995]
  stargazer_src[1995] <- ""
  # Save back
  writeLines(stargazer_src, con="stargazer/R/stargazer-internal.R")
  # Compile and install the patched package
  install.packages("stargazer", repos = NULL, type="source")
  